bool loadConfig() {                                       // Завантаження даних збереженних в файлі config.json
  File configFile=SPIFFS.open("/config.json", "r");       // Відкриваемо файл на читання
  if(!configFile){                                        // якщо файл не знайдено ствоюємого його та записуємо в ньго данні з наших змінних
    if(printCom) Serial.println("Failed to open config file");
    saveConfig();                                         // Створюємо файл
    configFile.close();
    return false;                                         // Повернення з помилкою
  }
  size_t size = configFile.size();                        // Перевіряємо ромір файлу, будемо використовувати файл довжиною в 1024 байта
  if (size > 1024) {                                      //
    if (printCom) Serial.println("Config file size is too large");
    configFile.close();    
    return false;                                         // Повернення з помилкою
  }
  jsonConfig = configFile.readString();                   // завантажуємо файл конфігурації в глобальну змінну
    DynamicJsonBuffer jsonBuffer;                         // Резервуємо память для json обекту буфер може розти по мірі необхідності переважно для ESP8266 
    configFile.close();                                   //
    JsonObject& root = jsonBuffer.parseObject(jsonConfig);//
    ssidAP = root["ssidAP"].as<String>();                 //
    passwordAP = root["asswordAP"].as<String>();          // Так отримуємо строку
    ssid = root["ssid"].as<String>();                     //
    password = root["password"].as<String>();             //
    ntpServerName = root["ntpServerName"].as<String>();
    timeZone = root["timeZone"];                          // Так отримуємо число
    weatherKey = root["weatherKey"].as<String>();         //
    weatherHost = root["weatherHost"].as<String>();       //
    cityID1 = root["cityID1"].as<String>();               //
    cityID2 = root["cityID2"].as<String>();               //
    hour = root["hour"];                                  //
    minute = root["minute"];                              //
    second = root["second"];                              //
    day = root["day"];                                    //
    month = root["month"];                                //
    year = root["year"];                                  //
    dayOfWeek = root["dayOfWeek"];                        //
    updateOTA = root["updateOTA"];                        //
    rotate = root["rotate"];                              //
    volBrightnessD = root["volBrightnessD"];              //
    volBrightnessN = root["volBrightnessN"];              //
    timeBrightnessD = root["timeBrightnessD"];            //
    timeBrightnessN = root["timeBrightnessN"];            //
    if (printCom) Serial.println("\r\n Load Config");
    if (printCom) Serial.println(jsonConfig);
    return true;                                          //
}

bool saveConfig(){                                        // 
  DynamicJsonBuffer jsonBuffer;                           // 
  JsonObject& json=jsonBuffer.parseObject(jsonConfig);    //
  json["ssidAP"]=ssidAP;                                  //
  json["passwordAP"]=passwordAP;                          //
  json["ssid"]=ssid;                                      //
  json["password"]=password;                              //
  json["ntpServerName"]=ntpServerName;                    //
  json["timeZone"]=timeZone;                              //
  json["weatherKey"]=weatherKey;                          //
  json["weatherHost"]=weatherHost;                        //
  json["cityID1"]=cityID1;                                //
  json["cityID2"]=cityID2;                                //
  json["hour"]=hour;                                      //
  json["minute"]=minute;                                  //
  json["second"]=second;                                  //
  json["day"]=day;                                        //
  json["month"]=month;                                    //
  json["year"]=year;                                      //
  json["dayOfWeek"]=dayOfWeek;                            //
  json["updateOTA"]=updateOTA;                            //
  json["rotate"]=rotate;                                  //
  json["volBrightnessD"]=volBrightnessD;                  //
  json["volBrightnessN"]=volBrightnessN;                  //
  json["timeBrightnessD"]=timeBrightnessD;                //
  json["timeBrightnessN"]=timeBrightnessN;                //
  json.printTo(jsonConfig);                               //
  File configFile=SPIFFS.open("/config.json", "w");       // Відкриваємо файл для запису
  if(!configFile){
    configFile.close();
    return false;
  }
  json.printTo(configFile);                               //
  if(printCom) Serial.println("\r\n Save Config");
  if(printCom) Serial.println(jsonConfig);
  configFile.close();
  return true;
}
