/*  ВЕРСІЯ:             |
                                      |
  GND______GPIO2____GPIO0____RX/GPIO3 |
 TX/GPIO1___CH_______RST______VCC     |
--------------------------------------|
 Піни LED------ESP-01----NodeMCU 1.0  |
                                      |
  DataIn_______GPIO 2______D8         |
  LOAD/CS______GPIO 0______D7         |
  CLK__________GPIO 3______D6         |
______________________________________|
*/
#include "Arduino.h"
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <FS.h> 
#include <ArduinoJson.h>
#include <ArduinoOTA.h>
#include <ESP8266HTTPUpdateServer.h> 
#include <OneWire.h>
#include "P_funct.js.h"
#include "P_style.css.h"
#include "P_boot.css.h"
#include "P_edit.h"
#include "P_index.h"
#include "P_time.h"
#include "P_weat.h"
#include "P_led.h"
#include "P_update.h"
#include "P_help.h"
ESP8266HTTPUpdateServer httpUpdater;
WiFiClient client;
ESP8266WebServer server(80);                                              // Веб сервер
File fsUploadFile;
IPAddress apIP(192, 168, 4, 1);
// =======================================================================
// CHANGE YOUR CONFIG HERE:
// =======================================================================
String ssid        = "***";                                        // Назва локального WiFi
String password    = "***";                                        // Пароль локального WiFi
String ssidAP      = "WiFi-Clock";                                        // Назва точки доступу
String passwordAP  = "" ;                                                 // пароль точки доступу
String weatherKey  = "***";
String weatherLang = "ua";
String cityID1     = "756135";                                            // Warsaw
String cityID2     = "703845";                                            // Kryvyy Rih
// =======================================================================
#define printCom 1
#define MAX_DIGITS 16
#define NUM_MAX 4
//Сохраняем яркость
int volBrightnessD  = 8;
int volBrightnessN  = 2;
int timeBrightnessD = 7;
int timeBrightnessN = 23;
int rotate = 90;
//for ESP-01 module
//#define DIN_PIN   2   // D4
//#define CS_PIN    0   // D3
//#define CLK_PIN   3   // D9/RX
//#define buzzerPin 14  // TX/GPIO1
//for NodeMCU 1.0
#define DIN_PIN   15  // D8
#define CS_PIN    13  // D7
#define CLK_PIN   12  // D6
#define buzzerPin 14  // D5
#define D3 5     

// Поддерживаемые датчики
#define DS18S20_ID 0x10
#define DS18B20_ID 0x28

OneWire  ds(D3);                             // DS18B20 підключено до 10 піну (резистор на 4.7к обовязковий)
#include "max7219.h"
#include "fonts.h"
boolean WIFI_connected = false;
// Настройка оновлення часу
IPAddress timeServerIP;
String ntpServerName = "time.nist.gov";
const int NTP_PACKET_SIZE = 48;
byte packetBuffer[ NTP_PACKET_SIZE];
WiFiUDP udp;
unsigned int localPort = 2390;
static const uint8_t monthDays[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};        // Кількість днів у місяцях
#define LEAP_YEAR(Y) (((1970+Y)>0) && !((1970+Y)%4) && (((1970+Y)%100)||!((1970+Y)%400)))   // Високосні літа
String weatherHost = "api.openweathermap.org";
String cityID;
String weatherMain = "";
String weatherDescription = "";
String weatherLocation = "";
String country;
int humidity;
float pressure;
float temp;
String tempz;
int clouds;
int windDeg;
float windSpeed;
String dw, _month;
String jsonConfig = "{}";                   // 
//---------------------------змінні для роботи локального годинника
int timeZone = 2;                                                            //  часовий пояс
bool isDayLightSaving=false;
long localEpoc=0;
long localMillisAtUpdate=0;
int hour=7, minute=52, second=0, month=6, day=14, dayOfWeek=4;
int year=2017;
bool statusUpdateNtpTime = 0;                                                // якщо не "0" - то останнє оновленя часу було вдалим
String y, mon, wd, d, h, m, s, mes;
uint8_t hourTest[3], minuteTest[3];
int secFr, lastSecond;
String date;
float buy;
float sale;
String cityName;
int cityId;
String currencyRates="        no kurs        ";
String weatherString;
String kursString="    нема курсу валют \220  $   \221   \222   \223      ";
byte dig[MAX_DIGITS]={0};
byte digold[MAX_DIGITS]={0};
byte digtrans[MAX_DIGITS]={0};
int dx=0;
int dy=0;
byte del=0;
int updateOTA=1; 
int znak;
float celsius;
int HighByte, LowByte, TReading, Tc_100, SignBit, Whole, Fract;
int Desa;
int Odyn;
//==============================================================================================
void setup(){
  Serial.begin(115200);
  initMAX7219();
  sendCmdAll(CMD_SHUTDOWN,1);
  sendCmdAll(CMD_INTENSITY,1); 
  SPIFFS.begin();
//***********HTTP сторінки для налаштуваня ESP
  server.on("/", [](){Serial.println("admin.html"); server.send_P(200, "text/html", PAGE_WiFiSettings);});                   // Start HTTP Server for configuration //
  server.on("/time.htm", [](){Serial.println("time.html"); server.send_P(200, "text/html", PAGE_TimeSettings);}); 
  server.on("/weather.htm", [](){Serial.println("weather.html"); server.send_P(200, "text/html", PAGE_WertherSettings);});
  server.on("/led.htm", [](){Serial.println("led.html"); server.send_P(200, "text/html", PAGE_LedSettings);});
  server.on("/update.htm", [](){Serial.println("update.html"); server.send_P(200, "text/html", PAGE_UpdateSettings);});
  server.on("/help.htm", [](){Serial.println("help.htm"); server.send_P(200, "text/html", PAGE_Help);});
  server.on("/edit.htm", [](){Serial.println("help.htm"); server.send_P(200, "text/html", PAGE_Edit);});
  server.on("/style.css", [](){Serial.println("style.css"); server.send_P ( 200, "text/plain", PAGE_Style_css);});
  server.on("/function.js", [](){Serial.println("microajax.js"); server.send_P ( 200, "text/plain", PAGE_function_js);});
  server.on("/bootstrap.min.css", [](){Serial.println("style.css"); server.send_P ( 200, "text/plain", PAGE_bootstrap_css);});  
  server.onNotFound([]() {(404, "text/plain", "FileNotFound");});
//************
  loadConfig();
  localMillisAtUpdate=millis();
  localEpoc=(hour*60*60+minute*60+second);
  udp.begin(localPort);
  pinMode(buzzerPin, OUTPUT);
  
//************ WiFi connect
  wifiConnect();
  if(printCom) Serial.println("");
  if(printCom) Serial.print("Connected: "); 
  if(printCom) Serial.println(WiFi.localIP());
// ***********  OTA SETUP
  if(updateOTA){
    ArduinoOTA.setPort(8266);
    ArduinoOTA.setHostname("ESP-Clock"); 
    ArduinoOTA.onEnd([](){ESP.restart();});
    ArduinoOTA.onError([](ota_error_t error){Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR && printCom) Serial.println("Auth Failed");
      else if (error == OTA_BEGIN_ERROR && printCom) Serial.println("Begin Failed");
      else if (error == OTA_CONNECT_ERROR && printCom) Serial.println("Connect Failed");
      else if (error == OTA_RECEIVE_ERROR && printCom) Serial.println("Receive Failed");
      else if (error == OTA_END_ERROR && printCom) Serial.println("End Failed");
      ESP.restart(); 
    });
    ArduinoOTA.begin();
  }
  server_init();
}

//=====================================================================================================================
//=====================================================================================================================
void loop(){
 if(updateOTA) ArduinoOTA.handle();                                                     // зберігаємо можливість пошивки по OTA
  server.handleClient();                                                                // дозволяємо HTTP серверу відповідать на запити
  updateTime();                                                                         // оновлюємо час
  if(second!=lastSecond){                                                               // на початку нової секунди скидаємо secFr в "0"
    lastSecond=second;
    if(printCom) Serial.print("secFr=");
    if(printCom) Serial.println(secFr);
    secFr=0;
  } else secFr++;                                                                       // якщо секунда ще не скінчилась то нарощуємо лічильник циклів secFr
  if(minute==0&&second==0&&secFr==0&&(hour>=7&&hour<=23)){                              // сигнал кожду годину од 7 до 23 години
    tone(buzzerPin, 2000, 40);
    delay(200);
    tone(buzzerPin, 2000, 40);
    delay(200);
      noTone(buzzerPin);
     
    
  }
  if(hour==22&&minute==55){                                                             // якщо наш час - то іде повідомлення для коханої
    printStringWithShift("                             ",30);
    return;
  }            
  if((statusUpdateNtpTime==0&&second==5)||(minute==0&&second==5)) timeUpdateNTP();      // оновлюємо час із інтернету кожен час в 0 хвилин, 5 сеунд,
                                                                                        // або кожну хвилину і 5 секунд , якщо остання спроба оновленя була невдалою
  if(second==15){                                                                       // кожну хвилину + 15 секунд виводимо якесь повідомленя
    if(minute%3==1){                                                                    // виводимо повідомлення курсу валют
      printStringWithShift(date.c_str(),25);
    }else if(minute%3==2){                                                              // виводимо погоду в місті №1
      cityID=cityID1;
      getWeatherData();  
      getWeatherDataz();   
      printStringWithShift(weatherString.c_str(),30);
    } else {                                                                            // виводимо погоду в місті №2
      cityID=cityID2;
      getWeatherData();   
      getWeatherDataz(); 
      printStringWithShift(weatherString.c_str(),30);
    }
  }
 if((second==45)&&secFr==0) temper();
 if(second<=45){                                                                       // з 45-ї секунди виводимо на екран температуру 
    if(!(millis()%30)) showAnimClock();                                                 // кожні 0,03 секунди виводимо анімацію годинника
  }
  else if(secFr==0) showSimpleTemp();
  if(second==50&&secFr==00&&WiFi.status()!=WL_CONNECTED){                               // на початку каждої 50-ї секунди перевіряемо WiFi підключеня
    WIFI_connected=false;
  }
  if(second==50&&(minute%10==1||minute%10==6)&&!WIFI_connected){                        // якщо нема WiFi підключення то кожну 1, 6, 11, 16...56 хвилину і 50 секунд
    wifiConnect();                                                                      // пробуємо підключитися до WiFi
  }
  if(secFr==0){                                                                         // кожну нову секунду змінюємо яскравість єкрану
    if(hour>=timeBrightnessD&&hour<timeBrightnessN) sendCmdAll(CMD_INTENSITY,volBrightnessD);
    else sendCmdAll(CMD_INTENSITY,volBrightnessN);
  }
}

//===============================================================================================================================================
// ===========================ВИВІД НА ЕКРАН ТЕМПЕРАТУРИ=========================================================================================
void showSimpleTemp(){
  dx=dy=0;
  clr();
   if(Desa < 1){                                                                       //  
  showDigit(znak, 7, fontUA);
  showDigit(Odyn, 14, dig6x8);
  showDigit(144, 21, fontUA);
  showDigit(112, 27, fontUA);
  }
 else {
  showDigit(znak, 0, fontUA);  
  showDigit(Desa, 7, dig6x8);
  showDigit(Odyn, 14, dig6x8);
  showDigit(144, 21, fontUA);
  showDigit(112, 27, fontUA);
 }
  refreshAll();
}

// ===========================ВИВІД НА ЕКРАН АНІМАЦІЙНОГО ГОДИННИКА==============================================================================
void showAnimClock(){
  byte digPos[4]={1,8,18,25};
  int digHt=16;
  int num=4; 
  int i;
  if(del==0) {
    del=digHt;
    for(i=0; i<num; i++) digold[i]=dig[i];
    dig[0]=hour/10?hour/10:10;
    dig[1]=hour%10;
    dig[2]=minute/10;
    dig[3]=minute%10;
    for(i=0; i<num; i++)  digtrans[i]=(dig[i]==digold[i])?0:digHt;
  } else
    del--;
  clr();
  for(i=0; i<num; i++){
    if(digtrans[i]==0){
      dy=0;
      showDigit(dig[i], digPos[i], dig6x8);
    } else {
      dy=digHt-digtrans[i];
      showDigit(digold[i], digPos[i], dig6x8);
      dy=-digtrans[i];
      showDigit(dig[i], digPos[i], dig6x8);
      digtrans[i]--;
    }
  }
  dy=0;
  if((secFr>=7000&&secFr<14000)||secFr>=21000){                                // мерегтіння двокрапок в годиннику підвязуємо до личильника циклів
    setCol(15, WIFI_connected?0x66:0x60);
    setCol(16, WIFI_connected?0x66:0x60);
  }
  if(statusUpdateNtpTime){                                                     // якщо останнє оновленя часу було вдалим, то двокрапки в годиннику будуть анімовані
    if(secFr>=0&&secFr<7000){
      setCol(15, WIFI_connected?0x24:0x20);
      setCol(16, WIFI_connected?0x42:0x40);
    }
    if(secFr>=14000&&secFr<21000){
      setCol(15, WIFI_connected?0x42:0x40);
      setCol(16, WIFI_connected?0x24:0x20);
    }
  }
  refreshAll();
}

// =======================================================================
void showDigit(char ch, int col, const uint8_t *data){
  if(dy<-8 | dy>8) return;
  int len=pgm_read_byte(data);
  int w=pgm_read_byte(data+1+ch*len);
  col+=dx;
  for(int i=0; i<w; i++)
    if(col+i>=0&&col+i<8*NUM_MAX){
      byte v=pgm_read_byte(data+1+ch*len+1+i);
      if(!dy) scr[col+i]=v; else scr[col+i] |= dy>0?v>>dy:v<<-dy;
    }
}

// =======================================================================
void setCol(int col, byte v){
  if(dy<-8 | dy>8) return;
  col+=dx;
  if(col>=0&&col<8*NUM_MAX)
    if(!dy) scr[col]=v; else scr[col]|=dy>0?v>>dy:v<<-dy;
}

// =======================================================================
int showChar(char ch, const uint8_t *data){
  int len=pgm_read_byte(data);
  int i,w=pgm_read_byte(data+1+ch*len);
  for(i=0; i<w; i++)
    scr[NUM_MAX*8+i]=pgm_read_byte(data+1+ch*len+1+i);
    scr[NUM_MAX*8+i]=0;
  return w;
}

// ===========================КОНВЕРТАЦІЯ СИМВОЛІВ В РАЗІ ВИКОРИСТАННЯ УКРАЇНСЬКИХ ЛІТЕР===========================================
int dualChar = 0;
unsigned char convertUA(unsigned char _c){
  unsigned char c=_c;
  if(c==208){
    dualChar=1;
    return 0;
  } else if(c==209||c==210){
    dualChar=2;
    return 0;
  }
  if(c==32&&dualChar!=3){
    dualChar=3;
    return c;
  }
  if(dualChar==1){
    if(c>=144&&c<192){
      c+=48;
    }
    dualChar=0;
    return c;
  }
  if(dualChar==2){
    if(c >= 128 && c < 144){
      c += 112;
    } 
    switch(_c) {
      case 144: c =  133; break;
      case 145: c =  149; break;
    }
    dualChar = 0;
    return c;
  }
}

// ===========================ДРУКУВАННЯ БІГУЧОГО СИМВОЛУ с - символ, shiftDelay - швидкість=====================================
void printCharWithShift(unsigned char c, int shiftDelay) {
  c = convertUA(c);
  if (c < ' ') return;
  c -= 32;
  int w = showChar(c, fontUA);
  for (int i=0; i<w+1; i++) {
    delay(shiftDelay);
    scrollLeft();
    refreshAll();
  }
}

// ===========================ДРУКУВАННЯ БІГУЧОЇ СТРОКИ *s - текст, shiftDelay - швидкість==========================================
void printStringWithShift(const char* s, int shiftDelay){
  while (*s){                                                   // коли працює ця функція, основний цикл зупиняється
    printCharWithShift(*s, shiftDelay);
    s++;
// ArduinoOTA.handle();                                         //
    server.handleClient();                                      // зберігаемо можливість відповіді на HTML запити під час бігучої стоки
  }
}

// ===========================ОНОВЛЕННЯ ЛОКАЛЬНОГО ЧАСУ (ЛОКАЛЬНІ ЧАСИ)===============================================================
void updateTime(){
  long curEpoch = localEpoc + ((millis() - localMillisAtUpdate) / 1000);
  long epoch = round(curEpoch + 86400L) % 86400L;
  hour = ((epoch  % 86400L) / 3600) % 24;
  minute = (epoch % 3600) / 60;
  second = epoch % 60;
}

// ===========================ОНОВЛЕННЯ МЕРЕЖЕВОГО ЧАСУ (перевірка в три проходи)====================================================
void timeUpdateNTP(){
  if(!WIFI_connected) return;
  statusUpdateNtpTime=1;
  for(int timeTest=0; timeTest<3; timeTest++){
    if (printCom) Serial.print("Proba #" );
    if (printCom) Serial.println(timeTest+1);
    updateTime();
    getNTPtime();
    hourTest[timeTest]=hour;                              // записуємо години
    minuteTest[timeTest]=minute;                          // записуємо хвилини
    if(statusUpdateNtpTime==0){
      if (printCom) Serial.print("ERROR TIME!!!\r\n" );
        return;
    }
    if(timeTest>0){
      if((hourTest[timeTest]!=hourTest[timeTest-1]||minuteTest[timeTest]!=minuteTest[timeTest-1])){
        statusUpdateNtpTime=0;
        if (printCom) Serial.print("ERROR TIME!!!\r\n" );
        return;
      }
    }
  }
  statusUpdateNtpTime=1;
  localMillisAtUpdate = millis();
  localEpoc = (hour * 60 * 60 + minute * 60 + second);
  convertDw();
  convertMonth();
  date = "     " + dw + ", " + String(day) + " " + _month + " " + String(year) + " рік                 ";
  if (printCom) Serial.print(String(hour)+":"+String(minute)+":"+String(second)+" ");//
  if (printCom) Serial.print(String(day)+"-"+String(month)+"-"+String(year)+" DW="+String(dayOfWeek)+"\r\n");
  if (printCom) Serial.println("Time update OK");
}

// ===========================ОТРИМАННЯ ДАТИ ТА ЧАСУ ВІД СЕРВЕРА ТОЧНОГО ЧАСУ =============================================================
void getNTPtime(){
  WiFi.hostByName(ntpServerName.c_str(), timeServerIP); 
  int cb;
  for(int i=0; i<3; i++){
    memset(packetBuffer, 0, NTP_PACKET_SIZE);
    packetBuffer[0] = 0b11100011;
    packetBuffer[1] = 0;
    packetBuffer[2] = 6;
    packetBuffer[3] = 0xEC;
    packetBuffer[12]  = 49;
    packetBuffer[13]  = 0x4E;
    packetBuffer[14]  = 49;
    packetBuffer[15]  = 52;
    udp.beginPacket(timeServerIP, 123);                     //NTP порт 123
    udp.write(packetBuffer, NTP_PACKET_SIZE);
    udp.endPacket();
    delay(800);                                             // чекаємо пів секуни
    cb = udp.parsePacket();
    if (!cb && printCom) Serial.println("no packet yet..." + String (i+1)); 
    if (!cb && i==2) {                                      // якщо час не отримано
      statusUpdateNtpTime=0;
      return;                                               // вихіз з getNTPtime()
    }
    if(cb) i=3;
  }
  if(cb){                                                   // якщо отримали пакет з серверу
    udp.read(packetBuffer, NTP_PACKET_SIZE);
    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    unsigned long lowWord = word(packetBuffer[42], packetBuffer[43]);
    unsigned long secsSince1900 = highWord << 16 | lowWord;
    const unsigned long seventyYears=2208988800UL;        // Unix час станом на 1 січня 1970. в секундах, то 2208988800:
    unsigned long epoch=secsSince1900-seventyYears;
    boolean summerTime;
    if(month<3 || month>10) summerTime=false;             // не переходимо на літній час в січні, лютому, листопаді і грудню
    if(month>3 && month<10) summerTime=true;              // Sommerzeit лічимо в квіні, травні, червені, липні, серпені, вересені
    if(month==3&&(hour+24*day)>=(3+24*(31-(5*year/4+4)%7))||month==10&&(hour+24*day)<(3+24*(31-(5*year/4+1)%7))) summerTime=true; 
    epoch=epoch+timeZone*3600+(3600*(isDayLightSaving && summerTime));      
    year=0;
    int days=0;
    uint32_t time;
    time=epoch/86400;
    hour=(epoch%86400L)/3600;
    minute=(epoch%3600)/60;
    second=epoch%60;
    dayOfWeek=(((time)+4)%7)+1;
    while((unsigned)(days+=(LEAP_YEAR(year)?366:365))<=time){
      year++;
    }
    days-=LEAP_YEAR(year)?366:365;
    time-=days;
    days=0;
    month=0;
    uint8_t monthLength=0;
    for (month=0; month<12; month++) {
      if (month==1){
        if(LEAP_YEAR(year)) monthLength=29;
        else monthLength=28;
      }
      else monthLength=monthDays[month];
      if (time>=monthLength) time-=monthLength;
      else break;
    }
    month=month+1;
    day=time+1;
    year+=1970;
    return;
  }
  if (printCom) Serial.println("Nie ma czasu(((");
}

//===============================================================================================================================//
//                              БЕРЕМО ПОГОДУ З САЙТУ api.openweathermap.org                                                     //
//===============================================================================================================================//
void getWeatherData(){
  if(!WIFI_connected) return;
  if (printCom) Serial.print("connecting to "); 
  if (printCom) Serial.println(weatherHost);
  if (client.connect(weatherHost.c_str(), 80)) {
    client.println(String("GET /data/2.5/weather?id=") + cityID + "&units=metric&appid=" + weatherKey + "&lang="+ weatherLang + "\r\n" +
                "Host: " + weatherHost + "\r\nUser-Agent: ArduinoWiFi/1.1\r\n" +
                "Connection: close\r\n\r\n");
  } else {
    if (printCom) Serial.println("connection failed");
    return;
  }
  int repeatCounter = 0;
  while (!client.available() && repeatCounter < 10) {
    delay(500);
    if (printCom) Serial.println("w.");
    repeatCounter++;
  }
  String line;
  while (client.connected() && client.available()) {
    char c = client.read(); 
    if (c == '[' || c == ']') c = ' ';
    line += c;
  }
  client.stop();
  if (printCom) Serial.println(line);
  DynamicJsonBuffer jsonBuf;
  JsonObject &root = jsonBuf.parseObject(line);
  if (!root.success())
  {
    if (printCom) Serial.println("parseObject() failed");
    return;
  }
  weatherDescription = root["weather"]["description"].as<String>();
  weatherDescription.toLowerCase(); convertWeatherDes();
  cityName = root ["name"] .as<String>();
  cityId = root ["id"]; convertCity();
  temp = root["main"]["temp"];
  humidity = root["main"]["humidity"];
  pressure = root["main"]["pressure"];
  pressure = (pressure/1.3332239) - 24;
  windDeg = root["wind"]["deg"];
  windSpeed = root["wind"]["speed"];
  clouds = root["clouds"]["all"];
  String windDegString;
  if (windDeg>=345 || windDeg<=22)  windDegString = "\211";    //"Північний";
  if (windDeg>=23 && windDeg<=68)   windDegString = "\234";    //"Північно-східний";
  if (windDeg>=69 && windDeg<=114)  windDegString = "\230";    //"Східний";
  if (windDeg>=115 && windDeg<=160) windDegString = "\235";    //"Південно-східний";
  if (windDeg>=161 && windDeg<=206) windDegString = "\210";    //"Південний";
  if (windDeg>=207 && windDeg<=252) windDegString = "\232";    //"Південно-західний";
  if (windDeg>=253 && windDeg<=298) windDegString = "\231";    //"Західний";
  if (windDeg>=299 && windDeg<=344) windDegString = "\233";    //"Північно-західний";
  weatherString = "         " + cityName + ", зараз:    \212 " + String(temp,0) + ("\202") + "C   ";
  weatherString += "  \213 " + String(humidity) + "%   ";
  weatherString += "  \215 " + String(pressure, 0) + "ммРс   ";
  weatherString += "  \214 " + windDegString + " " + String(windSpeed,1) + "м/с   ";
  weatherString += "  \216 " + String(clouds) + "%   ";
  weatherString += weatherDescription + "        ";                              //
}

// =======================================================================//
//               Беремо ПРОГНОЗ!!! погоди з сайту openweathermap.org      //
// =======================================================================//
void getWeatherDataz(){
  if (client.connect(weatherHost.c_str(), 80)) {
    client.println(String("GET /data/2.5/forecast/daily?id=") + cityID + "&units=metric&appid=" + weatherKey + "&lang=" + weatherLang + "&cnt=2" + "\r\n" +
                "Host: " + weatherHost + "\r\nUser-Agent: ArduinoWiFi/1.1\r\n" +
                "Connection: close\r\n\r\n");
  } else {
    if (printCom) Serial.println("connection failed nit prognoza");
    return;
  }
  String line;
  int  repeatCounter = 0;
  while (!client.available() && repeatCounter < 10) {
    delay(500);
    repeatCounter++;
  }
  while (client.connected() && client.available()) {
    char c = client.read(); 
    if (c == '[' || c == ']') c = ' ';
    line += c;
  }
  tvoday(line);
  client.stop();
  DynamicJsonBuffer jsonBuf;
  JsonObject &root = jsonBuf.parseObject(tempz);
  if (!root.success())
  {
    if (printCom) Serial.println("parseObject() failed");
    return;
  }
  float tempMin = root ["temp"]["min"];
  float tempMax = root ["temp"]["max"];  
  float wSpeed = root ["speed"];
  int wDeg = root ["deg"];
  weatherDescription = root ["weather"]["description"].as<String>();
  String wDegString;
  if (wDeg>=345 || wDeg<=22)  wDegString = "\211";    //"Північний";
  if (wDeg>=23 && wDeg<=68)   wDegString = "\234";    //"Північно-східний";
  if (wDeg>=69 && wDeg<=114)  wDegString = "\230";    //"Східний";
  if (wDeg>=115 && wDeg<=160) wDegString = "\235";    //"Південно-східний";
  if (wDeg>=161 && wDeg<=206) wDegString = "\210";    //"Південний";
  if (wDeg>=207 && wDeg<=252) wDegString = "\232";    //"Південно-західний";
  if (wDeg>=253 && wDeg<=298) wDegString = "\231";    //"Західний";
  if (wDeg>=299 && wDeg<=344) wDegString = "\233";    //"Північно-західний";
  weatherString += "Завтра:   \212" + String(tempMin,1) + "-" + String(tempMax,1) + "\202" + "C  " + weatherDescription;
  weatherString += "  \214 " + wDegString + " " + String(wSpeed,1) + "м/с                   ";
}

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void wifiConnect(){
  if (printCom) Serial.print("Connecting WiFi ");
  printStringWithShift("Підключеня до WiFi   ",10);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid.c_str(), password.c_str());
  for(int i=0; i<20; i++){
    if(WiFi.status() == WL_CONNECTED){
      WIFI_connected = true;
      if (printCom) Serial.print("IP address:       ");
      if (printCom) Serial.println(WiFi.localIP());
      String aaa=WiFi.localIP().toString();
      printStringWithShift("IP address: ", 15);
      printStringWithShift(aaa.c_str(), 25);
      timeUpdateNTP();
      return;
    }
    if (printCom) Serial.print(".");
    delay(500);
  }
  Serial.println("Setting AP mode default parameters");
  WiFi.disconnect();
  WiFi.mode(WIFI_AP);
  WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
  WiFi.softAP(ssidAP.c_str(), passwordAP.c_str());
  printStringWithShift("Підключіться до точки доступу WiFi-Clock і введіть в браузері адресу: 192.168.4.1         ", 35);
  if (printCom) Serial.print("Wifi ip:");
  if (printCom) Serial.println(WiFi.softAPIP());
}

// =======================================================================
void tvoday(String line){
  String s;
  int strt=line.indexOf('}');
  for(int i=1; i<=4; i++){
    strt=line.indexOf('}', strt+1);
  }
  s=line.substring(2+strt, line.length());
  tempz=s;
}

// ===========================КОНВЕРТАЦІЯ НАЗВ МІСТ НА УКРАЇНСЬКУ МОВУ============================================
void convertCity(){
  switch(cityId) {
    case 756135 : cityName = "Варшава";    break;
    case 703845 : cityName = "Кривий Ріг"; break;
    case 703448 : cityName = "Київ";       break;
    case 698740 : cityName = "Одеса";      break;
    case 709930 : cityName = "Дніпро";     break;
    case 710791 : cityName = "Черкаси";    break;
    case 702550 : cityName = "Львів";      break;
    case 706448 : cityName = "Херсон";     break;
    case 700569 : cityName = "Миколаїв";   break;
    case 687700 : cityName = "Запоріжжя";  break;
    case 706483 : cityName = "Харків";     break;
    case 709717 : cityName = "Донецьк";    break;
    case 702658 : cityName = "Луганськ";   break;
    case 696643 : cityName = "Полтава";    break;
    case 692194 : cityName = "Суми";       break;
    case 710735 : cityName = "Чернігів";   break;
    case 686967 : cityName = "Житомир";    break;
    case 695594 : cityName = "Рівне";      break;
    case 705812 : cityName = "Кропивницький"; break;
    case 690688 : cityName = "Умань";      break;
    case 689558 : cityName = "Вінниця";    break;
    case 706369 : cityName = "Хмельницький"; break;
    case 691650 : cityName = "Тернопіль";  break;
    case 702569 : cityName = "Луцьк";      break;
    case 704617 : cityName = "Ковель";     break;
    case 710719 : cityName = "Чернівці";   break;
    case 707471 : cityName = "Івано-Франківськ"; break;
    case 692372 : cityName = "Стрий";      break;
    case 700646 : cityName = "Мукачево";   break;
    case 690548 : cityName = "Ужгород";    break;
  }
}

// ===========================КОНВЕРТАЦІЯ НАЗВ ДНІВ ТИЖНЯ НА УКРАЇНСЬКУ МОВУ============================================
void convertDw(){
  switch(dayOfWeek){
    case 2 : dw = "Понеділок"; break;
    case 3 : dw = "Вівторок"; break;
    case 4 : dw = "Середа"; break;
    case 5 : dw = "Четвер"; break;
    case 6 : dw = "П'ятниця"; break;
    case 7 : dw = "Субота"; break;
    case 1 : dw = "Неділя"; break;
  }
}

// ===========================КОНВЕРТАЦІЯ НАЗВ МІСЯЦІВ НА УКРАЇНСЬКУ МОВУ============================================
void convertMonth(){
  switch(month){
    case 1 : _month = "січня"; break;
    case 2 : _month = "лютого"; break;
    case 3 : _month = "березня"; break;
    case 4 : _month = "квітня"; break;
    case 5 : _month = "травня"; break;
    case 6 : _month = "червня"; break;
    case 7 : _month = "липня"; break;
    case 8 : _month = "серпня"; break;
    case 9 : _month = "вересня"; break;
    case 10 : _month = "жовтня"; break;
    case 11 : _month = "листопада"; break;
    case 12 : _month = "грудня"; break;
  }
}

// ===========================КОНВЕРТАЦІЯ ХМАРНОСТІ НА УКРАЇНСЬКУ МОВУ============================================
void convertWeatherDes(){
  if(weatherDescription == "clear sky") weatherDescription = "  чисте небо  "; // 0-8% тучи
  else if(weatherDescription == "few clouds") weatherDescription = "  малохмарно  "; //12-20% тучи
  else if(weatherDescription == "scattered clouds") weatherDescription = "  розкидані хмари  "; //40% тучи
  else if(weatherDescription == "broken clouds") weatherDescription = "  хмарно з проясненнями  "; //75% тучи
  else if(weatherDescription == "overcast clouds") weatherDescription = "  дужа хмарність  "; //  93% тучи
  else if(weatherDescription == "light rain") weatherDescription = "  невеликий дощ  "; //  влажность  588-606 ммРс давление  36% тучи 93-97%    
  else if(weatherDescription == "moderate rain") weatherDescription = "  помірний дощ  "; // 83% влажность  731ммРс давление  % тучи
  else if(weatherDescription == "light intensity shower rain") weatherDescription = "  легкий проливний дощ  "; 
  else if(weatherDescription == "thunderstorm") weatherDescription = "  гроза  ";
  else if(weatherDescription == "haze") weatherDescription = "  туман  "; // 56% влажность 725-731ммРс давление  75% тучи
  else if(weatherDescription == "mist") weatherDescription = "  густий туман  "; // 100% влажность 735ммРс давление  75% тучи
  else if(weatherDescription == "shower sleet") weatherDescription = "  снег с дождем  ";
  else if(weatherDescription == "light shower snow") weatherDescription = "  небольшой снегопад  "; 
}

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void temper(){
  byte i;
  byte present = 0;
  byte data[12];
  byte addr[8];
  
  if (!ds.search(addr)) {
    ds.reset_search();
    return;
  }
  
  if (addr[0] != DS18S20_ID && addr[0] != DS18B20_ID) {
     Serial.print("Device is not a DS18x20 family device.\n");
      return;
  }
  
  ds.reset();
  ds.select(addr);
  
  // Запускаємо конвертацію
  ds.write(0x44, 1);
  
  // Чекаємо
  delay(1000);
  
  present = ds.reset();
  ds.select(addr); 

  // Зчитуємо ОЗП (ОЗУ) датчика 
  ds.write(0xBE); 

   // Обробляємо 9 байт
  for ( i = 0; i < 9; i++) {
    data[i] = ds.read();
  }
  
  // Вираховуємо темпертуру :) 
  LowByte = data[0];
  HighByte = data[1];

   TReading = (HighByte << 8) + LowByte;
   
   // Перевіряєм, чи мінусова температура 
   SignBit = TReading & 0x8000; 
   
   // Якщо мінусова температура інвертуємо значення та добавляємо одиницю 
   if (SignBit) { 
       TReading = (TReading ^ 0xffff) + 1; 
   }
   
   // Множимо на (100 * 0.0625) або 6.25
   Tc_100 = (6 * TReading) + TReading / 4;

   // Відділяєм ціле число та дріб  
   Whole = Tc_100 / 100;
   Fract = Tc_100 % 100;
   
   // Відділяєм окремо десятки та одиниці градуса
    Desa = Whole / 10;
    Odyn = Whole - (Desa * 10);
   
   if (SignBit){                    // Якщо мінусова температура то зміній "znak" присвоюємо значеня 13 ("-"),
      znak=13;}
      else if ( Whole<1)  znak=0;  // інакше якщо ціле число температури (змінна "Whole") менше 1 ((фактично 0)то зміній "znak" присвоюємо значеня 0 (" " пробіл)
      else znak=11;                //інакше "+"
}
