void server_init(void){
  server.on("/configs.json", handle_ConfigJSON);    // формування configs.json сторінки для передачі данних в web інтерфейс
  server.on("/ssid", handle_Set_Ssid);
  server.on("/ssidap", handle_Set_Ssidap);
  server.on("/timeZone", handle_time_zone);         // Установка часової зони по запиту типа http://192.168.2.100/timeZone?timeZone=3
  server.on("/weatherKey", handle_weatherKey);
  server.on("/ntpServerName", handle_ntpServerName);
  server.on("/weatherHost", handle_weatherHost);    // Установка сервера погоди по запиту типа http://192.168.2.100/weatherHost?weatherHost=api.openweathermap.org
  server.on("/cityID", handle_cityID);              // Установка ID міст по запиту типа http://192.168.2.100/cityID?cityID1=756135&cityID2=703845
  server.on("/updateOtta", handle_updateOta);
  server.on("/led", handle_led);
  server.on("/restart", handle_Restart);            // перезавантаження можуля по запиту типу http://192.168.1.11/restart?device=ok
  server.on("/resetConfig", handle_resetConfig);
  httpUpdater.setup(&server);
  server.begin();
}

void handle_ConfigJSON(){
  String json="{"; 
  json+="\"ssid\":\"";
  json+=ssid;
  json+="\",\"password\":\"";
  json+=password;
  json+="\",\"ssidAP\":\"";
  json+=ssidAP;
  json+="\",\"passwordAP\":\"";
  json+=passwordAP;
  json+="\",\"ip\":\"";
  json+=WiFi.localIP().toString();
  json+="\",\"ntpServerName\":\"";
  json+=ntpServerName;
  json+="\",\"timeZone\":\"";
  json+=timeZone;
  json+="\",\"weatherKey\":\"";
  json+=weatherKey;  
  json+="\",\"weatherHost\":\"";
  json+=weatherHost;
  json+="\",\"cityID1\":\"";
  json+=cityID1;
  json+="\",\"cityID2\":\"";
  json+=cityID2;
  json+="\",\"time\":\"";
  json+=(String(hour)+":"+(minute<10?"0":"")+String(minute)+":"+(second<10?"0":"")+String(second));
  json+="\",\"updateOTA\":\"";
  json+=updateOTA;
  json+="\",\"tbd\":\"";
  json+=timeBrightnessD;
  json+="\",\"vbd\":\"";
  json+=volBrightnessD;
  json+="\",\"tbn\":\"";
  json+=timeBrightnessN;
  json+="\",\"vbn\":\"";
  json+=volBrightnessN;
  json+="\",\"rotate\":\"";
  json+=rotate;
  json+="\"}"; 
  server.send(200, "text/json", json);
}

void handle_Set_Ssid(){
  ssid=server.arg("ssid").c_str();
  password=server.arg("password").c_str();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_Set_Ssidap(){
  ssidAP=server.arg("ssidAP").c_str();
  passwordAP=server.arg("passwordAP").c_str();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_ntpServerName(){
  ntpServerName=server.arg("ntpServerName").c_str();
  timeUpdateNTP();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_time_zone(){
  timeZone=server.arg("timeZone").toInt();
  timeUpdateNTP();
  saveConfig();
  server.send(200, "text/plain", "OK"); 
}

void handle_weatherKey(){
  weatherKey=server.arg("weatherKey").c_str();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_weatherHost(){
  weatherHost=server.arg("weatherHost").c_str();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_cityID(){
  cityID1=server.arg("cityID1").c_str();
  cityID2=server.arg("cityID2").c_str();
  saveConfig();
  server.send(200, "text/plain", "OK");
}

void handle_updateOta(){
  updateOTA=server.arg("updateOTA").toInt();
  saveConfig(); 
  server.send(200, "text/plain", "OK");
  delay(100);
  ESP.restart();
}  

void handle_led(){
  timeBrightnessD=server.arg("tbd").toInt();
  volBrightnessD=server.arg("vbd").toInt();
  timeBrightnessN=server.arg("tbn").toInt();
  volBrightnessN=server.arg("vbn").toInt();
  rotate=server.arg("rotate").toInt();
  server.send(200, "text/plain", "OK");
  saveConfig(); 
}

void handle_resetConfig(){
  String restart=server.arg("device");
  if(restart=="ok"){
    SPIFFS.format();
    server.send(200, "text/plain", "DEL CONFIG");
    //loadConfig();
    Serial.println(ESP.eraseConfig());
    delay(5000);
    ESP.reset();
  }
}

void handle_Restart(){
  String restart=server.arg("device");
  if(restart=="ok"){
    server.send(200, "text/plain", "OK"); 
    ESP.restart();
  }
}


